var buttons = require('./ui/mode_buttons'),
    dnd = require('./ui/dnd'),
    layer_switch = require('./ui/layer_switch');

module.exports = ui;

function ui(context) {
    function init(selection) {

        var container = selection
            .append('div')
            .attr('class', 'container');

        var map = container
            .append('div')
            .attr('class', 'map')
            .call(context.map)
            .call(layer_switch(context));

        context.container = container;

        return container;
    }

    function render(selection) {

        var container = init(selection);

        var right = container
            .append('div')
            .attr('class', 'right');

        var top = right
            .append('div')
            .attr('class', 'top');

        var pane = right
            .append('div')
            .attr('class', 'pane');
        
        top
            .append('div')
            .attr('class', 'buttons')
            .call(buttons(context, pane));

        dnd(context);
    }


    return {
        read: init,
        write: render
    };
}
